#!/usr/bin/perl

#######################################################
#                                                     #
#           Installations-Skript fr SqlGui           #
#                                                     #
#   Copyright (C) 2002 M.Beranek, marcus@beranek.de   #
#                                                     #
#                                                     #
#######################################################


#
# This script does the following:
#
# 1) install sqlguipart:
#   a) run configure
#   b) run make
#   c) run make install as root
#
# 2) install sqlgui:
#   a) run configure
#   b) run make
#   c) run make install as root
#
# 3) ask, which plugins to install
#
# 4) install sqlguimysql:
#   a) look for mysql.h
#   b) look for libmysqlclient
#   c) run configure with arguments
#   d) run make
#   e) run make install as root
#
# 5) install sqlguipgsql
#   a) look for libpq-fe.h
#   b) look for libpq
#   c) run configure with arguments
#   d) run make
#   e) run make install as root
#


print "\n\n---------------------------------\nInstallation-Script for sqlgui\n---------------------------------\n\n";


$configure = "./configure";
$make = "make";
$install = "su -c \"make install\"";


##############################
# Ask for plugins:
$with_mysql = 1;
$with_pgsql = 1;
$ask_mysql = "n";
$ask_pgsql = "n";

print "\n";
print "Do you want support for MySQL? [y/n] ";
chop( $ask_mysql = <STDIN> );
print "Do you want support for PostgreSQL? [y/n] ";
chop( $ask_pgsql = <STDIN> );
print "\n";

if( lc( $ask_mysql) eq "n" ){
  $with_mysql = 0;
}
if( lc( $ask_pgsql) eq "n" ){
  $with_pgsql = 0;
}


##############################
# Install SqlGuiPart:
$sqlguipart = listfile("sqlguipart-*.tar.gz");

$sqlguipartdir = $sqlguipart;
$sqlguipartdir =~ s/\.tar\.gz//g;

$t = "tar -xvzf $sqlguipart > /dev/null";
$c = "cd $sqlguipartdir && $configure > /dev/null";
$m = "cd $sqlguipartdir && $make > /dev/null";
$i = "cd $sqlguipartdir && $install > /dev/null";

print "Extracting archive. Please wait...\n";
#print "$t\n";
system( $t );
print "Now running configure. Please wait...\n";
#print "$c\n";
system( $c );
print "Now running make. Please wait...\n";
#print "$m\n";
system( $m );
print "Now installing. Please login as root:\n";;
#print "$i\n";
system( $i );


##############################
# Install Sqlgui:
$sqlgui = listfile("sqlgui-*.tar.gz");

$sqlguidir = $sqlgui;
$sqlguidir =~ s/\.tar\.gz//g;

$t = "tar -xvzf $sqlgui > /dev/null";
$c = "cd $sqlguidir && $configure > /dev/null";
$m = "cd $sqlguidir && $make > /dev/null";
$i = "cd $sqlguidir && $install > /dev/null";

print "Extracting archive. Please wait...\n";
#print "$t\n";
system( $t );
print "Now running configure. Please wait...\n";
#print "$c\n";
system( $c );
print "Now running make. Please wait...\n";
#print "$m\n";
system( $m );
print "Now installing. Please login as root:\n";;
#print "$i\n";
system( $i );


##############################
# Install MySQL
if($with_mysql){
  # Mysql:
  print "\n---------------------------------\nInstallation of MySQL-plugin\n---------------------------------\n\n";
  $sqlguimysql = listfile("sqlguimysql-*.tar.gz");
  $sqlguimysqldir = $sqlguimysql;
  $sqlguimysqldir =~ s/\.tar\.gz//g;
  $mysqlheader = finddir("mysql.h");
  $mysqllibs = finddir("libmysqlclient.a");
  $configure_mysql = "./configure --with-extra-includes=$mysqlheader --with-extra-libs=$mysqllibs";

  $t = "tar -xvzf $sqlguimysql > /dev/null";
  $c = "cd $sqlguimysqldir && $configure_mysql > /dev/null";
  $m = "cd $sqlguimysqldir && $make > /dev/null";
  $i = "cd $sqlguimysqldir && $install > /dev/null";

  print "Extracting archive. Please wait...\n";
  #print "$t\n";
  system( $t );
  print "Now running configure. Please wait...\n";
  #print "$c\n";
  system( $c );
  print "Now running make. Please wait...\n";
  #print "$m\n";
  system( $m );
  print "Now installing. Please login as root:\n";;
  #print "$i\n";
  system( $i );

}

##############################
# Install PostgreSQL
if($with_pgsql){
  print "\n---------------------------------\nInstallation of PostgreSQL-plugin\n---------------------------------\n\n";
  $sqlguipgsql = listfile("sqlguipgsql-*.tar.gz");
  $sqlguipgsqldir = $sqlguipgsql;
  $sqlguipgsqldir =~ s/\.tar\.gz//g;
  $pgsqlheader = finddir("libpq-fe.h");
  $pgsqllibs = finddir("libpq.a");
  $configure_pgsql = "./configure --with-extra-includes=$pgsqlheader --with-extra-libs=$pgsqllibs";

  $t = "tar -xvzf $sqlguipgsql > /dev/null";
  $c = "cd $sqlguipgsqldir && $configure_pgsql > /dev/null";
  $m = "cd $sqlguipgsqldir && $make > /dev/null";
  $i = "cd $sqlguipgsqldir && $install > /dev/null";

  print "Extracting archive. Please wait...\n";
  #print "$t\n";
  system( $t );
  print "Now running configure. Please wait...\n";
  #print "$c\n";
  system( $c );
  print "Now running make. Please wait...\n";
  #print "$m\n";
  system( $m );
  print "Now installing. Please login as root:\n";;
  #print "$i\n";
  system( $i );

}

##############################
# Run SqlGui:

print "\n\n===================================================================\n";
print "SqlGui should be installed now.\nBe sure to have KDEDIR in your Path.\nI can try to start sqlgui for you now.\nIf sqlgui doesn't start, you may need to adjust your path manually,\nor something went wrong with the intallation.\nIn this case, please read the README-file for further instructions.\n";
print "===================================================================\n";

print "\nShall I start sqlgui now? [y/n] ";

chop( $runnow = <STDIN> );

if (lc($runnow) eq "y"){
  exec( "sqlgui" )
} else {
  print "\n\nHmmm... ?!?\n\n";
  sleep 3;
  print "I will not run sqlgui...\nI will not run sqlgui...\nI will not run sqlgui...\nI will not run sqlgui...\nI will not run sqlgui...\nI will not run sqlgui...\n\n :(\n\n";
}


exit(0);

##############################
sub fatalerror( @m ){
  ($msg) = @_;
  print "\n======\nERROR:\n======\n$msg\n\naborting...\n\n";
  exit(0);
}

###############################################
#
# finddir: searches for file via locate
# and gives a selection if more then one found
#
# returns the path to the selected file
#
###############################################
sub finddir(){

  ($lookfor) = @_;

  $command = "locate $lookfor";

  $header = qx{locate $lookfor};

  $comment = "Found:";

  @files = split( "\n", $header );
  $s = scalar( @files );
  if($s>1){
    print "Found more than one $lookfor:\n----------------------------\n";
    $comment = "Your choice:";
    $r = 0;
    for(@files){
      $r++;
      print "[$r]: $_\n"
    }
    print "\n----------------------------\nPlease select number: ";
    chop( $number = <STDIN> );
    $headerfile = $files[ $number-1 ]
  } else {
    $headerfile = $files[ 0 ]
  }
  if($s==0){
    fatalerror("No $lookfor found.");
  }

  print "\n$comment $headerfile\n=> Path: ";
  $headerpath = $headerfile;
  $headerpath =~ s/^(.+)\/$lookfor/\1/g;
  print  "$headerpath\n\n";

  return $headerpath;
}


###############################################
#
# listfile: searches for files in actual dir
# and gives a selection if more then one found
#
# returns the selected file
#
###############################################
sub listfile(){

  ($lookfor) = @_;

  $command = "ls $lookfor";

  $header = qx{ls $lookfor};

  $comment = "Found:";

  @files = split( "\n", $header );
  $s = scalar( @files );
  if($s>1){
    print "Found more than one $lookfor:\n----------------------------\n";
    $comment = "Your choice:";
    $r = 0;
    for(@files){
      $r++;
      print "[$r]: $_\n"
    }
    print "\n----------------------------\nPlease select number: ";
    chop( $number = <STDIN> );
    $headerfile = $files[ $number-1 ]
  } else {
    $headerfile = $files[ 0 ]
  }
  if($s==0){
    fatalerror("No $lookfor found.");
  }

  print "\n$comment $headerfile\n\n";
  return $headerfile;
}
